- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- COPYRIGHT

# NAME

SSL_free_buffers, SSL_alloc_buffers - manage SSL structure buffers

# SYNOPSIS

     #include <openssl/ssl.h>

     int SSL_free_buffers(SSL *ssl);
     int SSL_alloc_buffers(SSL *ssl);

# DESCRIPTION

`SSL_free_buffers()` frees the read and write buffers of the given ssl. `SSL_alloc_buffers()` allocates the read and write buffers of the given ssl.

The SSL_MODE_RELEASE_BUFFERS mode releases read or write buffers whenever the buffers have been drained. These functions allow applications to manually control when buffers are freed and allocated.

After freeing the buffers, the buffers are automatically reallocated upon a new read or write. The `SSL_alloc_buffers()` does not need to be called, but can be used to make sure the buffers are preallocated. This can be used to avoid allocation during data processing or with `CRYPTO_set_mem_functions()` to control where and how buffers are allocated.

# RETURN VALUES

The following return values can occur:

1. (Failure)

   The `SSL_free_buffers()` function returns 0 when there is pending data to be read or written. The `SSL_alloc_buffers()` function returns 0 when there is an allocation failure.

2. (Success)

   The `SSL_free_buffers()` function returns 1 if the buffers have been freed. This value is also returned if the buffers had been freed before calling `SSL_free_buffers()`. The `SSL_alloc_buffers()` function returns 1 if the buffers have been allocated. This value is also returned if the buffers had been allocated before calling `SSL_alloc_buffers()`.

# SEE ALSO

ssl(7), SSL_free(3), SSL_clear(3), SSL_new(3), SSL_CTX_set_mode(3), CRYPTO_set_mem_functions(3)

# COPYRIGHT

Copyright 2017-2020 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.